/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : Ptrc1.h
**     Project     : ProcessorExpert
**     Processor   : MK60DN512ZVMD10
**     Component   : PercepioTrace
**     Version     : Component 01.004, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-07-23, 09:29, # CodeGen: 359
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         uiTraceStart                                - dword Ptrc1_uiTraceStart(void);
**         vTraceStop                                  - void Ptrc1_vTraceStop(void);
**         vTraceClear                                 - void Ptrc1_vTraceClear(void);
**         uiTraceGetTraceBufferSize                   - dword Ptrc1_uiTraceGetTraceBufferSize(void);
**         vTraceGetTraceBuffer                        - void* Ptrc1_vTraceGetTraceBuffer(void);
**         vTraceSetTimerFrequency                     - void Ptrc1_vTraceSetTimerFrequency(dword frequency);
**         xTraceOpenLabel                             - traceLabel Ptrc1_xTraceOpenLabel(char *label);
**         vTraceUserEvent                             - void Ptrc1_vTraceUserEvent(traceLabel eventLabel);
**         vTracePrintF                                - void Ptrc1_vTracePrintF(traceLabel eventLabel, char *formatStr, ...);
**         vTraceStartStatusMonitor                    - void Ptrc1_vTraceStartStatusMonitor(void);
**         vTraceSetQueueName                          - void Ptrc1_vTraceSetQueueName(void *queue, char *name);
**         vTraceSetISRProperties                      - void Ptrc1_vTraceSetISRProperties(objectHandleType handle, char *name, char...
**         vTraceStoreISRBegin                         - void Ptrc1_vTraceStoreISRBegin(objectHandleType id);
**         vTraceStoreISREnd                           - void Ptrc1_vTraceStoreISREnd(void);
**         vTraceTaskSkipDefaultInstanceFinishedEvents - void Ptrc1_vTraceTaskSkipDefaultInstanceFinishedEvents(void);
**         vTraceTaskInstanceIsFinished                - void Ptrc1_vTraceTaskInstanceIsFinished(void);
**         vTraceExcludeTaskFromSchedulingTrace        - void Ptrc1_vTraceExcludeTaskFromSchedulingTrace(const char* name);
**
**     (c) Copyright Percepio AB, 2012
**     http      : www.percepio.se
**     mail      : info@percepio.com
**     Processor Expert port: Erich Styger, 2012
** ###################################################################*/

#ifndef __Ptrc1_HxTraceInitTraceData
#define __Ptrc1_H

/* MODULE Ptrc1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "UTIL1.h"

#include "Cpu.h"
#include "trcUser.h"




#define Ptrc1_uiTraceGetTraceBufferSize() \
  uiTraceGetTraceBufferSize()

/*
** ===================================================================
**     Method      :  Ptrc1_uiTraceGetTraceBufferSize (component PercepioTrace)
**
**     Description :
**         Gets the size of the recorder data structure. For use
**         together with vTraceGetTraceBuffer if you wish to implement
**         an own store/upload solution, e.g., in case a debugger
**         connection is not available for uploading the data.
**     Parameters  : None
**     Returns     :
**         ---             - Size of the trace buffer
** ===================================================================
*/

#define Ptrc1_vTraceGetTraceBuffer() \
  vTraceGetTraceBuffer()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceGetTraceBuffer (component PercepioTrace)
**
**     Description :
**         Return a pointer to the recorder data structure. Use this
**         together with uiTraceGetTraceBufferSize if you wish to
**         implement an own store/upload solution, e.g., in case a
**         debugger connection is not available for uploading the data.
**     Parameters  : None
**     Returns     :
**         ---             - Pointer to the trace buffer
** ===================================================================
*/

#define Ptrc1_vTraceSetTimerFrequency(frequency) \
  vTraceSetTimerFrequency(frequency)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceSetTimerFrequency (component PercepioTrace)
**
**     Description :
**         Use this to define the frequency of the timer/counter used
**         for timestamping (in Hz)
**     Parameters  :
**         NAME            - DESCRIPTION
**         frequency       - frequency
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_uiTraceStart() \
  uiTraceStart()
/*
** ===================================================================
**     Method      :  Ptrc1_uiTraceStart (component PercepioTrace)
**
**     Description :
**         Starts the trace.
**     Parameters  : None
**     Returns     :
**         ---             - returns 1 if trace has been started, 0
**                           otherwise.
** ===================================================================
*/

#define Ptrc1_vTraceStop() \
  vTraceStop()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceStop (component PercepioTrace)
**
**     Description :
**         Stops the trace.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceClear() \
  vTraceClear()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceClear (component PercepioTrace)
**
**     Description :
**         Clears the trace.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_xTraceOpenLabel(label) \
  xTraceOpenLabel(label)

/*
** ===================================================================
**     Method      :  Ptrc1_xTraceOpenLabel (component PercepioTrace)
**
**     Description :
**         Open/create symbol to use as user event handle for related
**         user events (conceptually like a file handle)
**     Parameters  :
**         NAME            - DESCRIPTION
**       * label           - Pointer to label
**     Returns     :
**         ---             - trace label
** ===================================================================
*/

#define Ptrc1_vTraceUserEvent(eventLabel) \
  vTraceUserEvent(eventLabel)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceUserEvent (component PercepioTrace)
**
**     Description :
**         Simple user event - store a label, created using
**         xTraceOpenLabel
**     Parameters  :
**         NAME            - DESCRIPTION
**         eventLabel      - trace label for the user
**                           event
**     Returns     : Nothing
** ===================================================================
*/

/* void Ptrc1_vTracePrintF(traceLabel eventLabel, char *formatStr, ...); */
#define Ptrc1_vTracePrintF vTracePrintF

/*
** ===================================================================
**     Method      :  Ptrc1_vTracePrintF (component PercepioTrace)
**
**     Description :
**         Advanced user event - like printf (but limited formatting
**         support - will improve)
**     Parameters  :
**         NAME            - DESCRIPTION
**         eventLabel      - trace label
**       * formatStr       - Pointer to format string
**         Variable_1      - open parameter list
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceStartStatusMonitor() \
  vTraceStartStatusMonitor()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceStartStatusMonitor (component PercepioTrace)
**
**     Description :
**         This starts a task to monitor the state of the recorder.
**         This task periodically prints a line to the console window,
**         which shows the number of events recorded and the latest
**         timestamp. This task calls vTracePortEnd when the recorder
**         has been stopped, where custom actions can be added, e.g.,
**         to store the trace to a file if a file system is available
**         on the device.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceSetQueueName(queue, name) \
  vTraceSetQueueName(queue, name)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceSetQueueName (component PercepioTrace)
**
**     Description :
**         Assigns a name to a FreeRTOS Queue, Semaphore or Mutex. This
**         function should  be called right after creation of the
**         queue/mutex/semaphore. If not using this function, the
**         queues/mutexes/semaphores will be presented by their numeric
**         handle only.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * queue           - Pointer to the queue
**       * name            - Pointer to name
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceSetISRProperties(handle, name, prioritiy) \
  vTraceSetISRProperties(handle, name, prioritiy)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceSetISRProperties (component PercepioTrace)
**
**     Description :
**         Registers an Interrupt Service Routine in the recorder
**         library, This must be called before using
**         vTraceStoreISRBegin to store ISR events. This is typically
**         called in the startup of the system, before the scheduler is
**         started. 
**     Parameters  :
**         NAME            - DESCRIPTION
**         handle          - handle to be used
**       * name            - Pointer to name
**         prioritiy       - priority
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceStoreISRBegin(id) \
  vTraceStoreISRBegin(id)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceStoreISRBegin (component PercepioTrace)
**
**     Description :
**         Registers the beginning of an Interrupt Service Routine.
**         This must not be interrupted by another ISR containing
**         recorder library calls, so if allowing nested ISRs this must
**         be called with interrupts disabled.
**     Parameters  :
**         NAME            - DESCRIPTION
**         id              - ID of the ISR
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceStoreISREnd() \
  vTraceStoreISREnd()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceStoreISREnd (component PercepioTrace)
**
**     Description :
**         Registers the end of an Interrupt Service Routine. This must
**         not be interrupted by another ISR containing recorder
**         library calls, so if allowing nested ISRs this must be
**         called with interrupts disabled.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceTaskSkipDefaultInstanceFinishedEvents() \
  vTraceTaskSkipDefaultInstanceFinishedEvents()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceTaskSkipDefaultInstanceFinishedEvents (component PercepioTrace)
**
**     Description :
**         This is useful if there are implicit Instance Finish Events,
**         such as vTaskDelayUntil or xQueueReceive, in a task where an
**         explicit Instance Finish Event has been defined. This
**         function tells the recorder that only the explicitly defined
**         functions, using vTraceTaskInstanceIsFinished, should be
**         treated as Instance Finish Events for this task. The
**         implicit Instance Finish Events are thus disregarded for
**         this task.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceTaskInstanceIsFinished() \
  vTraceTaskInstanceIsFinished()

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceTaskInstanceIsFinished (component PercepioTrace)
**
**     Description :
**         This defines an explicit Instance Finish Event for the
**         current task. It tells the recorder that the current
**         instance of this task is finished at the next kernel call of
**         the task, e.g., a taskDelay or a queue receive. This
**         function should be called right before the api function call
**         considered to be the end of the task instance, i.e., the
**         Instance Finish Event.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define Ptrc1_vTraceExcludeTaskFromSchedulingTrace(name) \
  vTraceExcludeTaskFromSchedulingTrace(name)

/*
** ===================================================================
**     Method      :  Ptrc1_vTraceExcludeTaskFromSchedulingTrace (component PercepioTrace)
**
**     Description :
**         Excludes a task from the recording using a flag in the
**         Object Property Table. This can be useful if some irrelevant
**         task is very frequent and is "eating up the buffer". This
**         should be called the task has been created, but  before
**         starting the FreeRTOS scheduler.
**     Parameters  :
**         NAME            - DESCRIPTION
**         name            - name of the task
**     Returns     : Nothing
** ===================================================================
*/

/* END Ptrc1. */

#endif
/* ifndef __Ptrc1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
